Imports System.Xml
Imports TsChanManLibrary

Public Class clsXMLFunc

    ' TODO in V 0.5:
    Function bLF_ReadTSReaderXML(ByVal p_sXMLFile As String) As Boolean

        Dim xread As New XmlTextReader(p_sXMLFile) ' Reader mit der XML-Datei aus dem TSReader
        Dim i As Integer ' Channel-Index
        Dim l_bFertig As Boolean = False ' Wird auf TRUE gesetzt, sobald alle bentigten Daten vorhanden sind

        With xread
            .WhitespaceHandling = WhitespaceHandling.Significant
            .MoveToContent() ' Zum Anfang springen

            ' XML-Datei durchfetchen
            Do
                .Read() ' Eine Zeile lesen

                ' Frequenz-Daten lesen
                If .Name = "TUNED-MULTIPLEX" Then
                    Do
                        .Read()
                        ' Transponder-Daten lesen
                        If .Name = "TONE-ENABLED" Then
                            mdiXMLImport.w_nKHZ = .ReadElementString
                        End If
                        If .Name = "DISEQC-INPUT" Then
                            mdiXMLImport.w_nSwitch = .ReadElementString
                        End If
                        If .Name = "LNB-FREQUENCY" Then
                            mdiXMLImport.w_nLNBFreq = .ReadElementString
                        End If
                        If .Name = "FREQUENCY" Then
                            mdiXMLImport.w_nFrequency = .ReadElementString
                        End If
                        If .Name = "SYMBOL-RATE" Then
                            mdiXMLImport.w_nSymbolrate = .ReadElementString
                        End If
                        If .Name = "POLARITY" Then
                            mdiXMLImport.w_nPolarity = .ReadElementString
                        End If
                    Loop Until (.Name = "TUNED-MULTIPLEX")

                End If

                ' Senderdaten zur Frequenz
                If .Name = "PMTs" Then
                    Do
                        .Read()

                        ' Jetzt Channel's lesen
                        If .Name = "CHANNEL" Then
                            Do
                                .Read()
                                If .Name = "SERVICE-NUMBER" Then
                                    mdiXMLImport.w_sServiceNo(i) = .ReadElementString
                                End If
                                If .Name = "SHORT-NAME" Then
                                    mdiXMLImport.w_sChannelName(i) = .ReadElementString
                                End If
                            Loop Until (.Name = "CHANNEL")
                            ' Index erhhen (nchster Sender)
                            i += 1
                        End If

                        ' Habe alle Daten, Variable l_bFertig auf TRUE setzen
                        If .Name = "PMTs" Then
                            l_bFertig = True
                        End If
                    Loop Until (.Name = "PMTs")
                End If

                ' Wenn bereits alle Daten vorhanden sind, vorzeitig beenden
                If l_bFertig Then Exit Do

            Loop Until (.Name = "MPEG-TABLES")
        End With
    End Function
End Class
