Public Class AboutBox

    Private Sub AboutBox_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the title of the form.
        Dim ApplicationTitle As String
        If My.Application.Info.Title <> "" Then
            ApplicationTitle = My.Application.Info.Title
        Else
            ApplicationTitle = System.IO.Path.GetFileNameWithoutExtension(My.Application.Info.AssemblyName)
        End If
        Me.Text = String.Format("About {0}", ApplicationTitle)
        ' Initialize all of the text displayed on the About Box.
        Me.LabelProductName.Text = My.Application.Info.ProductName
        Me.LabelVersion.Text = String.Format("Version {0}", My.Application.Info.Version.ToString)
        Me.LabelCopyright.Text = My.Application.Info.Copyright

        Me.TextBoxDescription.Text = My.Application.Info.Description + Environment.NewLine + _
                                     Environment.NewLine + "Icons:" & Environment.NewLine & _
                                     "(c) Microsoft Corporation" + Environment.NewLine + _
                                     "(c) Phytonix" + Environment.NewLine + "(c) Famfamfam.com" + _
                                     Environment.NewLine + Environment.NewLine + _
                                     "Logo:" + Environment.NewLine + _
                                     "(c) http://www.photoshopbuddy.net/satellite.html"
    End Sub

    Private Sub OKButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKButton.Click
        Me.Close()
    End Sub
End Class
