Imports TsChanManLibrary

Public Class mdiXMLImport

    ' Index des Fensters im Wizard
    Dim w_nWindowIndex As Integer

    Public w_sServiceNo(150) As String ' Alle Kanal-Nummern
    Public w_sChannelName(150) As String ' Alle Kanal-Namen
    Public w_sServiceNoSel(150) As String ' Alle selektierten Kanal-Nummern
    Public w_sChannelNameSel(150) As String ' Alle selektierten Kanal-Namen

    Public w_nKHZ As Integer
    Public w_nSwitch As Integer
    Public w_nLNBFreq As Integer
    Public w_nFrequency As Integer
    Public w_nSymbolrate As Integer
    Public w_nPolarity As Integer

    ' Cancel-Button
    Private Sub pb_Cancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Cancel.Click

        ' Fenster schlieen
        Me.Close()
    End Sub

    ' Next-Button
    Private Sub pb_Next_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Next.Click

        ' Fenster-Index um eins erhhen
        w_nWindowIndex += 1

        Dim w_uXMLFunc As New clsXMLFunc

        ' Fenster-Index auswhlen
        Select Case w_nWindowIndex

            ' Von Schritt 1 zu Schritt 2
            Case 2
                If df_XMLFile.Text <> String.Empty Then

                    ' XML-Datei auseinandernehmen
                    w_uXMLFunc.bLF_ReadTSReaderXML(df_XMLFile.Text)

                    ' Zum 2ten Panel wechseln
                    Panel_1.Visible = False
                    lbl_StepNo.Text = "Step 2:"
                    lbl_Step.Text = "Please select the channels you'd like to import"
                    Panel_2.Visible = True

                    ' Sender ins Panel schreiben
                    Dim i As Integer = 0
                    chk_Channel.Items.Clear()
                    While w_sChannelName(i) <> String.Empty

                        chk_Channel.Items.Add(w_sChannelName(i))
                        i += 1
                    End While
                Else
                    MsgBox("Please select a valid TSReader XML-File")
                    w_nWindowIndex -= 1
                End If
            Case 3
                bLF_To3Panel()
            Case 4

                Dim i As Integer = 0
                While w_sChannelNameSel(i) <> String.Empty
                    i += 1
                End While
                'w_uXMLFunc.AddChannel_XML(i)
                'w_uXMLFunc.bFnc_RefreshChannels(0)
                Me.Close()
        End Select
    End Sub

    Private Sub pb_Prev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Prev.Click

        ' Fenster-Index um eins erniedrigen
        If w_nWindowIndex > 1 Then
            w_nWindowIndex -= 1
        End If

        Select Case w_nWindowIndex
            Case 1
                Panel_2.Visible = False
                lbl_StepNo.Text = "Step 1:"
                lbl_Step.Text = "Please select the XML File you created using TSReader"
                Panel_1.Visible = True
            Case 2
                Panel_3.Visible = False
                lbl_StepNo.Text = "Step 2:"
                lbl_Step.Text = "Please select the channels you'd like to import"
                Panel_2.Visible = True
                pb_Next.Text = "Next >"
        End Select

    End Sub

    Private Sub pb_Browse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Browse.Click
        ' OpenFileDialog deklarieren
        Dim openFileDialog1 As New OpenFileDialog()

        ' Parameter fr den OpenFileDialog festlegen
        openFileDialog1.InitialDirectory = "C:\"
        openFileDialog1.Filter = "TSReader XML-File (*.xml)|*.xml|All files (*.*)|*.*"
        openFileDialog1.FilterIndex = 1
        openFileDialog1.RestoreDirectory = True

        ' Dateiname in Textbox schreiben
        If openFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            df_XMLFile.Text = openFileDialog1.FileName
        End If
    End Sub

    ' Beim Laden des Form-Windows
    Private Sub mdiXMLImport_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' TODO!!!! Erstmal Fehler abfangen
        If cSettings.Cfg.cTvHardware <> ChannelType.DVBS Then
            MsgBox("The Import-Wizard does currently only work with DVB-s Hardware", MsgBoxStyle.Critical, "Cannot start Wizard")
            Me.Close()
        End If

        ' Arrays leeren
        Array.Clear(w_sServiceNo, 0, 150)
        Array.Clear(w_sChannelName, 0, 150)
        Array.Clear(w_sServiceNoSel, 0, 150)
        Array.Clear(w_sChannelNameSel, 0, 150)

        ' Panels im Fenster eindocken
        Panel_1.Dock = DockStyle.Fill
        Panel_2.Dock = DockStyle.Fill
        Panel_3.Dock = DockStyle.Fill

        ' Mit erstem Panel beginnen, Rest verstecken
        Panel_1.Visible = True
        Panel_2.Visible = False
        Panel_3.Visible = False

        ' Fenster-Index zurcksetzen (mit erstem beginnen)
        w_nWindowIndex = 1

    End Sub

    ' Wechseln vom 2ten zum 3ten Panel
    Function bLF_To3Panel() As Boolean

        Dim l_bReturn As Boolean = False ' Returnwert fr diese Funktion
        Dim w_uXML As New clsXMLFunc ' Klasse deklarieren

        ' Zum 3ten Panel wechseln
        Panel_2.Visible = False

        Dim i As Integer = 0
        Dim l_nIndex As Integer = 0
        While i < chk_Channel.CheckedItems.Count
            w_sChannelNameSel(i) = chk_Channel.CheckedItems(i).ToString
            l_nIndex = Array.IndexOf(w_sChannelName, w_sChannelNameSel(i))
            w_sServiceNoSel(i) = w_sServiceNo(l_nIndex)
            i += 1
        End While

        lbl_StepNo.Text = "Step 3:"
        lbl_Step.Text = "Please make sure this information is correct"
        Panel_3.Visible = True
        lbl_Freq.Text = w_nFrequency
        lbl_Symb.Text = w_nSymbolrate
        pb_Next.Text = "Finish"
        lbl_LNBFreq.Text = w_nLNBFreq
        lbl_Polar.Text = w_nPolarity
        lbl_KHZ.Text = w_nKHZ
        lbl_Switch.Text = w_nSwitch

        i = 0
        While w_sChannelNameSel(i) <> String.Empty
            lsb_Channels.Items.Add(w_sChannelNameSel(i))
            i += 1
        End While

    End Function

End Class